/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 IAP upgrade routine:
 Support serial port and USB for FLASH burning

 1. Use the IAP download tool to realize the download PA0 floating (default pull-up input)
 2. After downloading the APP, connect PA0 to ground (low level input), and press
 the reset button to run the APP program.
 3. The routine needs to install the CH372 driver.
 Note: FLASH operation keeps the frequency below 100Mhz, it is recommended that the main
 frequency of IAP be below 100Mhz
 
 */

#include "headfile.h"

extern u8 End_Flag;
#define WaitTimeMs 3000 // ȴʱ䣬msbootδڸʱڷͨѶԶתapp

#define APP_LEN_MAX  256            // 256ֽ(uint8_t)/4ֽ(uint32_t) = 64
u8 APP_RX_BUF1[APP_LEN_MAX] = {0};  //  һҳΪ256ֽ    0x00 = 1ֽ
u8 APP_RX_BUF2[APP_LEN_MAX] = {0};  //  һҳΪ256ֽ    0x00 = 1ֽ
u32 pdata[64] = {0};                // u8תΪu32飬flashб(д)
uint32_t APPLength = 0;             // appĳ(ĵڼ)
uint16_t spell;                     // u8תu32ĳ(ĵڼ)

uint16_t i;

/*********************************************************************
 * @fn      IAP_2_APP
 *
 * @brief   IAP_2_APP program.
 *
 * @return  none
 */
void IAP_2_APP(void) {
    NVIC_EnableIRQ(Software_IRQn);
    NVIC_SetPendingIRQ(Software_IRQn);
}
/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);                 // жȼ2
    Delay_Init();                                                   // ӳٺʼ
//    USART_Printf_Init(115200);                                      // 1ӡ Ϊcan1ųͻӡϢ Ϊusart2
    Can_init();                                                     // can1ʼ
//    USART3_CFG(57600);                                              // 3ʼ
    TIM2_Int_Init(9,7199);                                          //144Mhz/2 = apb1_clk(72Mhz)(tim2)  1msһ

    while(1)
   {
       if(TickMs > WaitTimeMs)
       {
           if(((*(vu32*)(Program_addr+4))&0xFF000000)==0x08000000) // жǷΪ0x08xxxxxx
           {
               IAP_2_APP();
           }
           else
           {
               TIM_ITConfig(TIM2, TIM_IT_Update, DISABLE);              // رtim2
               TIM_Cmd(TIM2, DISABLE);                                  // رtim2ʹ
               break;
           }
       }
       if(gucCANRecFlag)
       {
           gucCANRecFlag = 0;
           TIM_ITConfig(TIM3, TIM_IT_Update, DISABLE);
           TIM_Cmd(TIM3, DISABLE);
           break;
       }
   }
    while(1)
    {
//        if(gucCANRecFlag)
//        {
//            gucCANRecFlag = 0;
//
//        }
//        gucCANRecFlag ++;

        /* 3жϺдflash */
//        if( USART_GetFlagStatus(USART3, USART_FLAG_RXNE) != RESET)  // жǷ ־λǷ
//        {
//            UART_Rx_Deal();                                         // ִжݺǷȷȷղдFLASH
//        }
//        // ڴɣ־λEnd_Flag = 1; ת
//        if (End_Flag)                                               // жϱ־λ̽תAPP
//        {
//            Delay_Ms(10);
//            IAP_2_APP();
//            while(1);   // ǵɾ
//        }
        /* can1д */
        if(gucCANRecFlag)
        {
            gucCANRecFlag = 0;
            if(CanRxStructure.StdId == 0x01)            // յbinݰ
            {
                if(APPLength < 256)
                {
                    APP_RX_BUF1[APPLength] = rxbuf[i];
                    APPLength++;
                    if(APPLength == 256)
                    {
                        // رȫж
                        __disable_irq();
                        FLASH_Unlock_Fast();                                        // flash
                        FLASH_ErasePage_Fast(Program_addr);                         // ҳ
                        for(spell = 0; spell < 64; spell++) // ƴ64 64*4=256
                        {
                            uint16_t APP_RX_BUF1_SIZE = 0;      // u8תu32APP_RX_BUF1_SIZE(ĵڼ)
                            pdata[spell] = ((uint32_t)APP_RX_BUF1[APP_RX_BUF1_SIZE] << 24)
                            |((uint32_t)APP_RX_BUF1[APP_RX_BUF1_SIZE+1] << 16)
                            |((uint32_t)APP_RX_BUF1[APP_RX_BUF1_SIZE+2] << 8)
                            |(uint32_t)APP_RX_BUF1[APP_RX_BUF1_SIZE+3];
                            APP_RX_BUF1_SIZE += 4;
                        }
                        CH32_IAP_Program(Program_addr, (u32*)APP_RX_BUF1);          // iapд
                        Program_addr += 0x100;
                        __enable_irq();
                        // ָȫж
                    }
                }
                if(APPLength >= 256)
                {
                    APP_RX_BUF2[APPLength - 256] = rxbuf[i];
                    APPLength++;
                    if(APPLength == 512)
                    {
                        // رȫж
                        __disable_irq();
                        uint16_t APP_RX_BUF2_SIZE = 0;      // u8תu32APP_RX_BUF1_SIZE(ĵڼ)
                        FLASH_Unlock_Fast();                                        // flash
                        FLASH_ErasePage_Fast(Program_addr);                         // ҳ
                        for(spell = 0; spell < 64; spell++) // ƴ64 64*4=256
                        {
                            pdata[spell] = ((uint32_t)APP_RX_BUF2[APP_RX_BUF2_SIZE] << 24)
                            |((uint32_t)APP_RX_BUF2[APP_RX_BUF2_SIZE+1] << 16)
                            |((uint32_t)APP_RX_BUF2[APP_RX_BUF2_SIZE+2] << 8)
                            |(uint32_t)APP_RX_BUF2[APP_RX_BUF2_SIZE+3];
                            APP_RX_BUF2_SIZE += 4;
                        }
                        CH32_IAP_Program(Program_addr, (u32*)APP_RX_BUF2);          // iapд
                        Program_addr += 0x100;
                        APPLength = 0;
                        memset(APP_RX_BUF1, 0, sizeof(APP_RX_BUF1));
                        memset(APP_RX_BUF2, 0, sizeof(APP_RX_BUF2));
                        __enable_irq();
                        // ָȫж
                    }
                }
            }
            if(CanRxStructure.StdId == 0x02)            // ʣֽȫдflashмʹ0
            {
                FLASH_Unlock_Fast();                                        // flash
                FLASH_ErasePage_Fast(Program_addr);                         // ҳ
                CH32_IAP_Program(Program_addr, (u32*)APP_RX_BUF1);          // iapд
                Program_addr += 0x100;                  // дԿԲʱ
                FLASH_ErasePage_Fast(Program_addr);                         // ҳ
                CH32_IAP_Program(Program_addr, (u32*)APP_RX_BUF2);          // iapд
                Program_addr += 0x100;
                FLASH_Lock();
                Delay_Ms(10);                           // ȴһº,app2
                IAP_2_APP();
            }
        }
    }
}
